/**

Install Files for Flash on OSX Browsers including plugin and XPT

Arun Ranganathan -- arunerAtNoSpamAllowednetscape.com

Modify where appropriate and use this script as you please

This install script attempts to first install to 
HD::Library::Internet Plugins

Failing permission to install to HD::Library::Internet Plugins it will install to the app bundle

The app bundle is Netscape.app::Contents::MacOS::Plugins

**/

// Install Variables

var PLUGIN_FILE = "Shockwave Flash NP-PPC";

var COMPONENT_FILE = "flashplayer.xpt";

var VERSION = "7.0.19.0";

var PL_SIZE = 2000; // (Shared Library) Reserve a little extra space in KB
var CP_SIZE = 10; // (XPT file) Reserve a little extra space in KB

var SOFTWARE_NAME = "Shockwave Flash Player";

var PLID = "@macromedia.com/FlashPlayer7";

// Declare globally in case we need it
var errorGlobalInstall = 0;

var errorAppInstall = 0;

err = initInstall(SOFTWARE_NAME, PLID, VERSION);
if (err != 0)
{
	logComment("Install Failed at initInstall");
	cancelInstall(err);
}

// if we can install globally by adding files to the HD::Library::Internet Plug-ins folder
// then we are done and we should refreshPlugins and quit

if(globalInstall())
{
	resetError();
	err = performInstall();
	if(err == SUCCESS)
		refreshPlugins(true);
}
else
{
	//You cannot globalInstall because you do not have permissions for HD::Library Internet Plug-ins
	// addFile to HD::Library::Internet Plug-ins has returned errors
	// So, install to the app bundle (Netscape.app) plugins directory
	
	var plugins = getFolder("Plugins");
	if(verifyDiskSpace(plugins, PL_SIZE+CP_SIZE))
	{
		errorAppInstall = addFile(PLID, VERSION, PLUGIN_FILE, plugins, null);
		if (errorAppInstall != 0)
		{
			logComment("Failure to install to App Bundle plugins directory");
			cancellInstall();
			
		}
		else
		{
			errorAppInstall = addFile(PLID, VERSION, COMPONENT_FILE, plugins, null);
			if(errorAppInstall != 0)
			{
				logComment("Plugin will NOT be scriptable but we will not abort");
			}
		}
		resetError();
		err = performInstall();
		if(err == SUCCESS)
			refreshPlugins(true);
	}
	else
	{
		logComment("Not enough Disk Space in App Bundle plugins Directory");
		cancellInstall();
		
	}
}

function globalInstall()

{

// addFiles to Library/Internet Plug-ins if you can
// Here we will deploy a strategic hack to get to the location we desire.
// Assumption: the Macintosh HD may have a different label (e.g. ArunMac HD), 
// Thus we cannot accurately discern how to get to the area /Library/Internet Plug-ins.
// This is the subject of http://bugzilla.mozilla.org/show_bug.cgi?id=195148   

var subPath = "../Library/Internet Plug-ins";
var globalPlugins = getFolder("Mac System", subPath);

if(File.exists(globalPlugins))
{
	// install to this location if there is enough space
	
	if(verifyDiskSpace(globalPlugins, PL_SIZE+CP_SIZE))
	{
		// We have enough space
		
		errorGlobalInstall = addFile (PLID, VERSION, PLUGIN_FILE, globalPlugins, null);
		if (errorGlobalInstall != 0)
		{
			logComment("addFile plugin to global location failed " + errGlobalInstall);
			return false;
		}
		else
		{ 
			errorGlobalInstall = addFile(PLID, VERSION, COMPONENT_FILE, globalPlugins, null);
			if(errorGlobalInstall != 0)
			{
				
				//Lack of scriptability is a failed installation
				
				logComment("addFile component to global location failed " + errGlobalInstall);
				return false;
			}
			else
				return true;
			
					
	 	}
	}
	else
	{
		logComment("No Disk Space in HD::Library::Internet Plug-ins");
		return false;
	}
}
else
{
	logComment("Unable to locate HD::Library::Internet Plug-ins");
	return false;

}

}

function verifyDiskSpace(dirPath, spaceRequired)
{
  var spaceAvailable;

  // Get the available disk space on the given path
  spaceAvailable = fileGetDiskSpaceAvailable(dirPath);

  // Convert the available disk space into kilobytes
  spaceAvailable = parseInt(spaceAvailable / 1024);

  // do the verification
  if(spaceAvailable < spaceRequired)
  {
    logComment("Insufficient disk space: " + dirPath);
    logComment("  required : " + spaceRequired + " K");
    logComment("  available: " + spaceAvailable + " K");
    return(false);
  }

  return(true);
}